#define _SVID_SOURCE
#define _BSD_SOURCE

#include <string.h>
#include <sys/msg.h>
#include <stdio.h>
#include <stdlib.h>
#include "common.h"

int getMessage(Message * msg);

int main()
{
    const key_t key = getKey();
    const int queueId = msgget(key, 0666);
    if (queueId == -1)
    {
        fprintf(stderr, "Message queue get failed.\n");
        exit(EXIT_FAILURE);
    }

    Message msg;
    int haveToSendMsg = getMessage(&msg);
    size_t size = 0;
    while (haveToSendMsg == EXIT_SUCCESS)
    {
        SerializedMessage * serializedMsg = serializeMessage(&msg, USER_MESSAGE_TYPE, &size);
        freeMessage(&msg);

        int err = msgsnd(queueId, serializedMsg, size, 0);
        free(serializedMsg);
        if (err == -1)
        {
            fprintf(stderr, "Failed to send message.\n");
            exit(EXIT_FAILURE);
        }
        haveToSendMsg = getMessage(&msg);
    }

    return EXIT_SUCCESS;
}


int getMessage(Message * msg)
{
    char c;
    int skip;
    char buf[31];
    do
    {
        printf("Insert user? [y/n] ");
        scanf("%c", &c);
    }
    while (c != 'y' && c != 'Y' && c != 'n' && c != 'N');

    if (c == 'n' || c == 'N') return EXIT_FAILURE;
    printf("\n");

    printf("Name: ");
    scanf("%30s", buf);
    msg->name = strdup(buf);

    printf("Last name: ");
    scanf("%30s", buf);
    msg->lastName = strdup(buf);

    printf("Age: ");
    scanf("%u", &msg->age);

    printf("Email: ");
    scanf("%30s", buf);
    msg->email = strdup(buf);

    return EXIT_SUCCESS;
}
