#define _SVID_SOURCE

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "common.h"


void freeMessage(Message * msg)
{
    free(msg->name);
    free(msg->lastName);
    free(msg->email);

    msg->name = NULL;
    msg->lastName = NULL;
    msg->age = 0;
    msg->email = NULL;
}


SerializedMessage * serializeMessage(Message * const msg, const MessageType type,
    size_t * const size)
{
    const size_t nameLen = strlen(msg->name) +1;
    const size_t lastNameLen = strlen(msg->lastName) +1;
    const size_t emailLen = strlen(msg->email) +1;
    *size += nameLen + lastNameLen + sizeof(msg->age) + emailLen;

    SerializedMessage * ret = malloc(sizeof(SerializedMessage) + *size -1);
    ret->type = (long) type;
    char * buf = ret->buffer;
    strcpy(buf, msg->name);
    buf += nameLen;
    strcpy(buf, msg->lastName);
    buf += lastNameLen;
    unsigned int * ageBuf = (unsigned int *) buf;
    *ageBuf = msg->age;
    buf += sizeof(msg->age);
    strcpy(buf, msg->email);

    return ret;
}



Message * deserializeMessage(SerializedMessage * const msg)
{
    Message * ret = malloc(sizeof(Message));

    char * buf = msg->buffer;

    const size_t nameLen = strlen(buf) +1;
    ret->name = malloc(sizeof(char) * nameLen);
    strcpy(ret->name, buf);
    buf += nameLen;

    const size_t lastNameLen = strlen(buf) +1;
    ret->lastName = malloc(sizeof(char) * lastNameLen);
    strcpy(ret->lastName, buf);
    buf += lastNameLen;

    ret->age = *(unsigned int *) buf;
    buf += sizeof(ret->age);

    const size_t emailLen = strlen(buf) +1;
    ret->email = malloc(sizeof(char) * emailLen);
    strcpy(ret->email, buf);

    return ret;
}

key_t getKey()
{
    key_t ret = ftok("./server.x", 'k');
    if (ret == -1)
    {
        fprintf(stderr, "ftok() failed.\n");
        exit(EXIT_FAILURE);
    }
    return ret;
}
