#ifndef COMMON_H
#define COMMON_H

#include <sys/types.h>
#include <sys/ipc.h>

typedef enum MessageType
{
    USER_MESSAGE_TYPE = 5
} MessageType;


typedef struct SerializedMessage
{
    long type;
    char buffer[1];
} SerializedMessage;


typedef struct Message
{
    char * name;
    char * lastName;
    unsigned int age;
    char * email;
} Message;


void freeMessage(Message * msg);

SerializedMessage * serializeMessage(Message * const msg, const MessageType type,
    size_t * const size);

Message * deserializeMessage(SerializedMessage * const msg);

key_t getKey();

#endif
